#include <iostream>

using namespace std;

const int MAX=1002;
const int MAXV=101;
const int INF=0x7FFFFFF;

int N,V,A,W,Ans;
int P[MAX],C[MAX];
int F[MAX][MAXV];
int Buy[MAX];
struct
{
	int from,addition;
}G[MAX][MAXV];

void init()
{
	int i,j;
	freopen("arugal.in","r",stdin);
	freopen("arugal.out","w",stdout);
	cin >> N >> V >> A >> W;
	for (i=1;i<=N;i++)
	{
		cin >> P[i] >> C[i];
		for (j=0;j<=V;j++)
		{
			F[i][j]=INF;
		}
	}
	F[N+1][0]=INF;
}

void dynamic()
{
	int i,j,k,x,v;
	F[1][0]=0;
	for (i=1;i<=N;i++)
	{
		for (j=0;j<=V;j++)
		{
			if (F[i][j]==INF) continue;
			for (k=0;k<=A && j+k-P[i]<=V;k++)
			{
				if (j+k>=P[i])
				{
					x=j+k-P[i];//
					v=F[i][j] + k * C[i] + x * W;
					if (v < F[i+1][x])
					{
						F[i+1][x]=v;
						G[i+1][x].from=j;
						G[i+1][x].addition=k;
					}
				}
			}
		}
	}
	Ans=F[N+1][0];
	for (i=N+1,j=0;i>1;j=G[i--][j].from)
	{
		Buy[i-1]=G[i][j].addition;
	}
}

int main()
{
	init();
	dynamic();
	cout << Ans << endl;
	for (int i=1;i<=N;i++)
		cout << Buy[i] << endl;
	return 0;
}