#include <iostream>
#define MAX 20001
using namespace std;

typedef struct
{
	int x;
	bool s;
	int i;
}point;

point P[MAX];
int N,Ans;
int R[MAX];
bool Hash[MAX];
bool Ansp[MAX];

inline int cmp(const void *a,const void *b)
{
	if ( ((point *)a)->x == ((point *)b)->x &&  ((point *)a)->s == ((point *)b)->s)
	{
		if ( ((point *)a)->i > ((point *)b)->i )
			return -1;
		else
			return 1;
	}
	if ( ((point *)a)->x < ((point *)b)->x )
		return -1;
	if ( ((point *)a)->x > ((point *)b)->x )
		return 1;
	if ( !((point *)a)->s )
		return -1;
	return 1;
}

void init()
{
	int i,a,b;
	freopen("punch.in","r",stdin);
	freopen("punch.out","w",stdout);
	cin >> N;
	for (i=1;i<=N;i++)
	{
		a=i *2-1;
		b=a+1;
		scanf("%d%d",&P[a].x,&P[b].x);
		P[a].i=P[b].i=i;
		P[a].s=true;
		R[i]=P[b].x;
		
	}
	N*=2;
	qsort(P+1,N,sizeof(P[0]),cmp);
}

void solve()
{
	int i,level=0,Top=0;
	for (i=1;i<=N;i++)
	{
		if (P[i].x!=P[i-1].x || P[i].i<=Top)
			Ansp[Top]=true;
		if (P[i].s)
		{
			level++;
			Hash[P[i].i]=true;
			if (P[i].i>Top)
			{
				Top=P[i].i;
			}
		}
		else
		{
			level--;
			if (P[i].i==Top)
			{
				Hash[Top]=false;
				for (Top--;Top>=0;Top--)
				{
					 if (Hash[Top] && R[Top]>P[i].x)
						 break;
				}
			}
		}
	}
	N/=2;
	for (i=1;i<=N;i++)
		if (Ansp[i])
			Ans++;
}

int main()
{
	init();
	solve();
	cout << Ans << endl;
	return 0;
}
