#include <iostream>
#define MAX 51
#define MAXM 0x10000
#define INF 0x7FFFFFF
#define Warner INF
#define Space 0
#define Stone -1
#define Guard -2

using namespace std;

typedef struct
{
	int m;
	int elec;
}gird;

typedef struct
{
	int x,y;
	int step;
	unsigned int Key;
}point;

class tQueue
{
public:
	class linklist
	{
	public:
		linklist* next;
		point value;
		linklist()
		{
			next=0;
		}
	};
	linklist *first,*last;
	int size;
	void ins(point p)
	{
		if (size==0)
			first=last=new linklist;
		else
			last=last->next=new linklist;
		last->value=p;
		size++;
	}
	point pop()
	{
		point rtn=first->value;
		linklist *tfirst=first;
		first=first->next;
		delete tfirst;
		size--;
		return rtn;
	}
	void reset()
	{
		size=0;
		first=last=0;
	}
	tQueue()
	{
		reset();
	}
};


int N,M,Ans;
int dx[4]={1,-1,0,0},dy[4]={0,0,1,-1};
gird G[MAX][MAX];
bool vis[MAX][MAX][MAXM];
tQueue Q;

inline bool inrange(int x,int y)
{
	return x>=1 && x<=N && y>=1 && y<=N;
}

void init()
{
	int i,j,k,c,x,y;
	freopen("syndicate.in","r",stdin);
	freopen("syndicate.out","w",stdout);
	cin >> N >> M;
	for (i=1;i<=N;i++)
	{
		for (j=1;j<=N;j++)
		{
			cin >> c;
			if (c==Space)
				G[i][j].m=Space;
			else if (c==Stone)
				G[i][j].m=Stone;
			else if (c==Guard)
				G[i][j].m=Guard;
			else
			{
				if (c>=1 && c<=M)
				{
					G[i][j].m=c;
				}
				else
				{
					G[i][j].m=Warner;
					G[i][j].elec=c-M;
				}
			}
		}
	}
	for (i=1;i<=N;i++)
	{
		for (j=1;j<=N;j++)
		{
			if (G[i][j].m==Guard)
			{
				G[i][j].m=Stone;
				for (k=0;k<4;k++)
				{
					x=i+dx[k];
					y=j+dy[k];
					if (inrange(x,y) && G[x][y].m!=Guard)
						G[x][y].m=Stone;
				}
			}
		}
	}
}

inline bool getkey(unsigned int K,int p)
{
	return (bool)((K & (1 << (p-1))) >> (p-1));
}

void setkey(unsigned int &K,int p)
{
	K |=1 << (p-1);
}

int BFS()
{
	point i,j;
	int k;
	bool p;
	i.x=i.y=1;
	i.Key=i.step=0;
	vis[1][1][0]=true;
	Q.ins(i);
	while (Q.size)
	{
		i=Q.pop();
		for (k=0;k<4;k++)
		{
			j.Key=i.Key;
			j.x=i.x+dx[k];
			j.y=i.y+dy[k];
			j.step=i.step+1;
			if (inrange(j.x,j.y) && !vis[j.x][j.y][j.Key])
			{
				if (j.x==N && j.y==N)
				{
					return j.step;
				}
				p=false;
				if (G[j.x][j.y].m==Warner)
				{
					p=getkey(j.Key,G[j.x][j.y].elec);
				}
				else if (G[j.x][j.y].m>0)
				{
					setkey(j.Key,G[j.x][j.y].m);
					p=true;
				}
				if (G[j.x][j.y].m==Space || p)
				{
					vis[j.x][j.y][j.Key]=true;
					Q.ins(j);
				}
			}
		}
	}
	return -1;
}

int main()
{
	init();
	Ans=BFS();
	cout << Ans << endl;
	return 0;
}