#include <iostream>

using namespace std;

const int MAXM=1001;
const int MAXN=10001;
const int INF=0x7FFFFFFF;

int N,M,Ans;
int F[MAXN][MAXM];
int G[MAXN][MAXM];

void dynamic()
{
	int i,j;
	freopen("azshara.in","r",stdin);
	freopen("azshara.out","w",stdout);
	scanf("%d%d",&M,&N);
	for (i=1;i<=N;i++)
	{
		for (j=1;j<=M;j++)
		{
			scanf("%d",&G[i][j]);
			F[i][j]=-INF;
		}
	}
	for (i=1;i<=N;i++)
	{
		for (j=1;j<=M;j++)
		{
			if (G[i][j]==-1) continue;
			F[i][j]=F[i-1][j];
			if (j-1>=1 && F[i-1][j-1]>F[i][j] )
				F[i][j]=F[i-1][j-1];
			if (j+1<=M && F[i-1][j+1]>F[i][j] )
				F[i][j]=F[i-1][j+1];
			F[i][j]+=G[i][j];
		}
	}
	for (i=1;i<=M;i++)
	{
		if (F[N][i]>Ans)
			Ans=F[N][i];
	}
}

int main()
{
	dynamic();
	cout << Ans << endl;
	return 0;
}
